<!--
 ~ Copyright (c) 2005-2010, WSO2 Inc. (http://www.wso2.org) All Rights Reserved.
 ~
 ~ WSO2 Inc. licenses this file to you under the Apache License,
 ~ Version 2.0 (the "License"); you may not use this file except
 ~ in compliance with the License.
 ~ You may obtain a copy of the License at
 ~
 ~    http://www.apache.org/licenses/LICENSE-2.0
 ~
 ~ Unless required by applicable law or agreed to in writing,
 ~ software distributed under the License is distributed on an
 ~ "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 ~ KIND, either express or implied.  See the License for the
 ~ specific language governing permissions and limitations
 ~ under the License.
 -->
<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt"%>
<%@ taglib uri="http://wso2.org/projects/carbon/taglibs/carbontags.jar"
	prefix="carbon"%>
<%@ page import="org.apache.axis2.context.ConfigurationContext"%>
<%@ page import="org.wso2.carbon.CarbonConstants"%>
<%@ page import="org.wso2.carbon.ui.CarbonUIMessage"%>
<%@ page import="org.wso2.carbon.utils.ServerConstants"%>
<%@ page import="org.wso2.carbon.identity.entitlement.ui.client.EntitlementPolicyAdminServiceClient" %>
<%@ page import="org.wso2.carbon.ui.CarbonUIUtil" %>
<%@ page import="java.util.ResourceBundle" %>
<%@page import="java.lang.Exception"%>
<%@ page import="org.wso2.carbon.identity.entitlement.ui.dto.PolicySetDTO" %>
<%@ page import="java.util.List" %>

<jsp:useBean id="entitlementPolicyBean" type="org.wso2.carbon.identity.entitlement.ui.EntitlementPolicyBean"
             class="org.wso2.carbon.identity.entitlement.ui.EntitlementPolicyBean" scope="session"/>
<jsp:setProperty name="entitlementPolicyBean" property="*" />
<%
    String forwardTo = null;
    String[] algorithmNames = null;
    String[] policyIds = null;
    List<String> selectedPolicyIds = null;

    PolicySetDTO policySetDTO = entitlementPolicyBean.getPolicySetDTO();
    String serverURL = CarbonUIUtil.getServerURL(config.getServletContext(), session);
    ConfigurationContext configContext =
            (ConfigurationContext) config.getServletContext().getAttribute(CarbonConstants.
                    CONFIGURATION_CONTEXT);
    String cookie = (String) session.getAttribute(ServerConstants.ADMIN_SERVICE_COOKIE);
    String BUNDLE = "org.wso2.carbon.identity.entitlement.ui.i18n.Resources";
	ResourceBundle resourceBundle = ResourceBundle.getBundle(BUNDLE, request.getLocale());


    try {
        EntitlementPolicyAdminServiceClient client = new EntitlementPolicyAdminServiceClient(cookie,
                serverURL, configContext);
        algorithmNames = client.getEntitlementPolicyDataFromRegistry("policyCombiningAlgorithms");
        entitlementPolicyBean.setPolicyCombiningAlgorithms(algorithmNames);
        policyIds = client.getAllPolicyIds();

    } catch (Exception e) {
    	String message = resourceBundle.getString("error.while.loading.policy.resource");
        CarbonUIMessage.sendCarbonUIMessage(message, CarbonUIMessage.ERROR, request);
        forwardTo = "../admin/error.jsp";

%>
<script type="text/javascript">
    function forward() {
        location.href = "<%=forwardTo%>";
    }
</script>

<script type="text/javascript">
    forward();
</script>
<%
    }
%>

<fmt:bundle basename="org.wso2.carbon.identity.entitlement.ui.i18n.Resources">
	<carbon:breadcrumb label="create.policy.set"
		resourceBundle="org.wso2.carbon.identity.entitlement.ui.i18n.Resources"
		topPage="false" request="<%=request%>" />
<script type="text/javascript" src="../carbon/admin/js/breadcrumbs.js"></script>
<script type="text/javascript" src="../carbon/admin/js/cookies.js"></script>
<script type="text/javascript" src="extensions/js/vui.js"></script>
<script type="text/javascript" src="../admin/js/main.js"></script>
<script type="text/javascript" src="../ajax/js/prototype.js"></script>
<script type="text/javascript" src="../resources/js/resource_util.js"></script>
<script type="text/javascript" src="../resources/js/registry-browser.js"></script>
<script type="text/javascript" src="../yui/build/event/event-min.js"></script>
<script src="../yui/build/yahoo-dom-event/yahoo-dom-event.js" type="text/javascript"></script>
<script src="../entitlement/js/create-basic-policy.js" type="text/javascript"></script>
<link href="../entitlement/css/entitlement.css" rel="stylesheet" type="text/css" media="all"/>

    <script type="text/javascript">

    function removeRow(link){
        link.parentNode.parentNode.parentNode.removeChild(link.parentNode.parentNode);
    }

    function submitForm() {

    }

    function cancelForm() {
       location.href = 'index.jsp';
    }

    function addNewRow(){

        var comboBox = document.getElementById("policyIds");
        var policySetId = comboBox[comboBox.selectedIndex].value;
        var mainTable = document.getElementById('mainTable');
        var newTr = mainTable.insertRow(mainTable.rows.length);
        var cell1 = newTr.insertCell(0);
        var rowValue = mainTable.rows.length - 1;
        cell1.innerHTML = policySetId + '<input type="hidden" readonly="readonly"   value="' + policySetId +'" name="policyIds'+ rowValue +'" id="policyIds'+ rowValue +'"/>' ;

        var cell2 = newTr.insertCell(1);
        cell2.innerHTML = '<a onclick="removeRow(this)" style="background-image:url(images/delete.gif);" type="button" class="icon-link"></a>' ;
    }

    function doValidation() {

        var value = document.getElementsByName("policySetName")[0].value;
        if (value == '') {
            CARBON.showWarningDialog('<fmt:message key="policy.name.is.required"/>');
            return false;
        }
        return true;
    }

    function doCancel() {
        location.href = 'index.jsp?';
    }

    function doFinish() {
        document.createPolicySet.action = "update-policy-set.jsp?";
        if (doValidation()) {
            document.createPolicySet.submit();
        }
    }

    function doAddTarget() {

        if(doValidation()) {
            document.createPolicySet.action = "update-policy-set.jsp?";
            document.createPolicySet.submit();
        }
    }

</script>

	<div id="middle">
	<h2><fmt:message key='create.entitlement.policy.set'/></h2>
	<div id="workArea">
    <form name="createPolicySet" action="index.jsp" method="post">
    	<table class="styledLeft noBorders">
		<tbody>
            <tr>
                <td class="leftCol-med"><fmt:message key='policy.set.name'/><font class="required">*</font></td>
                <%
                    if(policySetDTO != null && policySetDTO.getPolicySetId() != null){
                %>
                    <td><input type="text" name="policySetName" id="policySetName" value="<%=policySetDTO.getPolicySetId()%>" class="text-box-big"/></td>
                <%
                    } else {
                %>
                    <td><input type="text" name="policySetName" id="policySetName" class="text-box-big"/></td>
                <%
                    }
                %>
            </tr>
            <tr>
                <td><fmt:message key="policy.combining.algorithm"/></td>
                <td>
                <select id="policyAlgorithmName" name="policyAlgorithmName">
                <%
                  if (algorithmNames != null && algorithmNames.length > 0) {
                      for (String algorithmName : algorithmNames) {
                          if(policySetDTO != null && algorithmName.equals(policySetDTO.getPolicyCombiningAlgId())){
                %>
                      <option value="<%=algorithmName%>" selected="selected"><%=policySetDTO.getPolicyCombiningAlgId()%></option>
                <%
                            } else {
                %>
                      <option value="<%=algorithmName%>"><%=algorithmName%></option>
                <%
                            }
                        }
                    }
                %>
                </select>
                </td>
            </tr>
            <tr>
                <td><fmt:message key='policy.set.description'/></td>
                <%
                    if(policySetDTO != null && policySetDTO.getDescription() != null){
                %>
                    <td><input type="text" name="policySetDescription" id="policySetDescription" value="<%=policySetDTO.getDescription()%>" class="text-box-big"/></td>
                <%
                    } else {
                %>
                    <td><input type="text" name="policySetDescription" id="policySetDescription" class="text-box-big"/></td>
                <%
                    }
                %>
            </tr>

            <tr>
                <td class="leftCol-med" style="vertical-align:top"><fmt:message
                            key="select.policies.policySets"/></td>
                <td>
                    <select id="policyIds" name="policyIds">
                    <%
                        if (policyIds != null && policyIds.length > 0) {
                            for (String policyId : policyIds) {
                    %>
                        <option value="<%=policyId%>"><%=policyId%></option>
                    <%
                            }
                        }
                    %>
                    </select>

                    <a onclick="addNewRow();" style='background-image:url(images/add.gif);float:none' type="button"
                       class="icon-link"></a>
                </td>
            </tr>
            <tr>
                <td colspan="2">
                    <table id="mainTable" class="styledLeft" style="width: 100%">
                    <thead>
                    <tr>
                        <th><fmt:message key="selected.policies"/></th>
                        <th><fmt:message key="action"/></th>
                    </tr>
                    </thead>
                            <tbody>

                            <%
                                if(policySetDTO != null && policySetDTO.getPolicyIds().size() > 0) {
                                    int i = 1;
                                    for(String policyId : policySetDTO.getPolicyIds()){
                            %>
                            <tr>
                                <td>
                                    <input type="hidden" value="<%=policyId%>" id="policyIds<%=i%>" name="policyIds<%=i%>"/>
                                    <%=policyId%>
                                </td>
                                <td><a onclick="removeRow(this)" style="background-image:url(images/delete.gif);" type="button" class="icon-link"></a></td>
                            </tr>

                            <%
                                        i++;
                                    }
                                }
                            %>
                        </tbody>
                    </table>
                </td>
            </tr>

            <tr>
                <td colspan="2" class="buttonRow">
                    <input class="button" type="button" value="<fmt:message key='finish'/>" onclick="doFinish();"/>
                    <input class="button" type="button" value="<fmt:message key='cancel'/>"  onclick="doCancel();"/>
                </td>
            </tr>
        </tbody>
    </table>    
	</form>
	</div>	
	</div>
</fmt:bundle>                      